#!/bin/bash
# set -x auskommentieren für den Debug Modus. Die Ausgabe erscheint in der Kommandozeile.
#set -x
#Taken from: http://www.kuemmel-digital.com/?p=363

# hier wird die Logfile-Datei definiert
# Logfile muss erst mit "sudo nano fritzbox.log" am Zielort erstellt werden erstellt werden

set -x

LOGFILE=/var/log/fritzbox.log
VPN_FILE=/etc/vpnc/fritzbox.conf

# hier wird die IP-Adresse von Fritzbox definiert. wenn die VPN Verbindung steht, dann sollte ping funktionieren.

myHost=8.8.8.8

# Wert -> wie oft soll gepingt werden

wert=4

# Ausgabe Wert für "count" soll bei erfolgreichen ping 4 sein, bei erfolglosen ping 0.

count=$(ping -c $wert $myHost | grep 'received' | awk '{print $4 }')

if [ $count -eq 4 ]

then

    # die kommenden echos sind die Info-Ausgaben in Logfile
    echo "$(date +%Y-%m-%d:%T) :Fritzbox mit der IP $myHost ist erreichbar und VPN Verbindung steht" | tee -a $LOGFILE

else

    echo "" | tee -a $LOGFILE

    echo "$(date +%Y-%m-%d:%T) :Fritzbox mit der IP $myHost ist nicht erreichbar" |tee -a $LOGFILE
    echo "$(date +%Y-%m-%d:%T) :VPN-Verbindung trennen" |tee -a $LOGFILE

    #hier wird das VPNC-Demon gestoppt, damit es nicht meher im Hintergrund lauft

#   /usr/sbin/vpnc-disconnect

    # oft ist die Wlan Verbindungen unterbrochen. hier werden alle Netzwerkverbindungen neugestartet.

    echo "$(date +%Y-%m-%d:%T) :Netzwerkverbindungen neu starten" | tee -a $LOGFILE

   /etc/init.d/networking restart

    # 12 Sekunden warten

    sleep 12

    # auslesen von der Wlan Ip-Adresse
    # grep Adresse muss bei Englischen Spracheinstellungen evtl. geändert werden. Mit dem Debug Modus ausprobieren

    # ipwlan=$(/sbin/ifconfig wlan0 | grep "inet Adresse" | cut -b 24-38)
    # echo "$(date +%Y-%m-%d:%T) :Netzwerkverbindungen wurde neugestart. WLAN IP-Adresse: $ipwlan " | tee -a $LOGFILE
    # echo "$(date +%Y-%m-%d:%T) :VPN Verbindung neu aufbauen, der Skript vpnc_fritzbox starten" | tee -a $LOGFILE

    # starten von VPNC-Demon. PID und VPN-IP Adresse auslesen

#    /usr/sbin/vpnc $VPN_FILE
#   pid=$(pidof vpnc)

#    ipvpn=$(/sbin/ifconfig tun0 | grep "inet Adresse" | cut -b 24-38)

#   echo "$(date +%Y-%m-%d:%T) :Die VPN-Verbindung wurde erfolgreich aufgebaut. die VPN IP-Adresse ist: $ipvpn. VPNC-Demon ist aktiv unter id: $(pidof vpnc)" | tee -a $LOGFILE

    echo "" | tee -a $LOGFILE

fi
